#include "Arduino.h"

#ifndef Sequence_h
#define Sequence_h

class Sequence
{
  public:
    Sequence(uint32_t siz, boolean looped);

    // rembobine la sequence pour commencer à jouer au début
    void rewindSequence();

    // efface la séquence
    void emptySequence();

    // mixe la séquence avec la séquence reçue. Rallonge la séquence si nécessaire.
    // Le mixage commence à l'endroit où on était dans la sequence.
    void mixSequence2(uint8_t *seq2, int nbSteps2);

    // les commandes suivantes créent une séquence avec un pattern
    // La taille donnée est en nombre de pas. Le framerate est de SEQ_FRAMERATE. La taille du pas est donc de 1/SEQ_FRAMERATE s
    
    // remplit la séquence avec un pattern carré de taille donnée
    void patternSquare(uint32_t siz);
    // remplit la séquence avec un pattern scie de taille donnée
    void patternSaw(uint32_t siz);
    // remplit la séquence avec un pattern triangle de taille donnée
    void patternTriangle(uint32_t siz);
    // remplit la séquence avec un pattern fade out de taille donnée
    void patternFadeOut(uint32_t siz);
    // remplit la séquence avec un pattern de nb dirac (pics)
    void patternDirac(uint32_t siz_on, uint32_t siz_off, uint32_t nb);

    // bas niveau
    uint8_t sequenceGetNextNote();
    boolean sequenceSetNextNote(uint8_t lightVal);
    boolean finished();
    uint8_t *sequence;
    uint32_t _siz;
  private:
    uint32_t _index;
    uint32_t _maxsiz;
    boolean _looped;
};

#endif

